import { Meta, Story, Canvas, Description } from '@storybook/addon-docs/blocks';
import readme from './readme.md';

<Meta
	title="Navigation/digi-navigation-vertical-menu-item"
	parameters={{
		actions: {
			handles: ['afOnPageChange']
		}
	}}
/>

<!-- Description pulled from auto generated Stencil docs -->

<Description markdown={readme} />

## Link

This is a menu item with a link

<Canvas>
	<Story name="Standard">
		/* html */
		{`
      <script>
        function setActiveMenuItem(target=null) {
          const menuItems = document.querySelectorAll('digi-navigation-vertical-menu-item[af-active="true"]');
          if(menuItems) {
            menuItems.forEach((el) => el.setAttribute('af-active', 'false'));
          }
          if(target) {
            target.setAttribute('af-active', 'true');
          }
        }
        document.addEventListener('afOnClick', (e) => {
          e.detail.preventDefault();
          if(e.target.matches('digi-navigation-vertical-menu-item:not([af-active-subnav])')) {
            setActiveMenuItem(e.target);
          }
        });
      </script>
      <digi-navigation-vertical-menu>
        <ul>
          <li><digi-navigation-vertical-menu-item af-text="Menu item" af-href="#"></digi-navigation-vertical-menu-item></li>
          <li>
            <digi-navigation-vertical-menu-item af-text="Menu item" af-href="#"></digi-navigation-vertical-menu-item>
            <ul>
              <li>
                <digi-navigation-vertical-menu-item af-text="Menu item" af-href="#"></digi-navigation-vertical-menu-item>
              </li>
            </ul>
          </li>
        </ul>
      </digi-navigation-vertical-menu>
    `}
	</Story>
</Canvas>

## Toggle button

This is a menu item without a link that is used as a toggle button to open/close the sub navigation

<Canvas>
	<Story name="Toggle">
		/* html */
		{`
      <script>
        function setActiveMenuItem(target=null) {
          const menuItems = document.querySelectorAll('digi-navigation-vertical-menu-item[af-active="true"]');
          if(menuItems) {
            menuItems.forEach((el) => el.setAttribute('af-active', 'false'));
          }
          if(target) {
            target.setAttribute('af-active', 'true');
          }
        }
        document.addEventListener('afOnClick', (e) => {
          e.detail.preventDefault();
          if(e.target.matches('digi-navigation-vertical-menu-item:not([af-active-subnav])')) {
            setActiveMenuItem(e.target);
          }
        });
      </script>
      <digi-navigation-vertical-menu>
        <ul>
          <li>
            <digi-navigation-vertical-menu-item af-text="Menu item" af-active-subnav="false">
            </digi-navigation-vertical-menu-item>
            <ul>
              <li><digi-navigation-vertical-menu-item af-text="Menu item" af-href="#"></digi-navigation-vertical-menu-item></li>
            </ul>
          </li>
        </ul>
      </digi-navigation-vertical-menu>
    `}
	</Story>
</Canvas>

## Link with icon

This is a menu item with a link with icon

<Canvas>
	<Story name="Icon">
		/* html */
		{`
      <script>
        function setActiveMenuItem(target=null) {
          const menuItems = document.querySelectorAll('digi-navigation-vertical-menu-item[af-active="true"]');
          if(menuItems) {
            menuItems.forEach((el) => el.setAttribute('af-active', 'false'));
          }
          if(target) {
            target.setAttribute('af-active', 'true');
          }
        }
        document.addEventListener('afOnClick', (e) => {
          e.detail.preventDefault();
          if(e.target.matches('digi-navigation-vertical-menu-item')) {
            setActiveMenuItem(e.target);
          }
        });
      </script>
      <digi-navigation-vertical-menu>
        <ul>
          <li>
            <digi-navigation-vertical-menu-item af-text="Menu item" af-href="#" af-active-subnav="true">
              <digi-icon af-name="paperclip" slot="icon"></digi-icon>
            </digi-navigation-vertical-menu-item>
            <ul>
              <li><digi-navigation-vertical-menu-item af-text="Menu item" af-href="#"></digi-navigation-vertical-menu-item></li>
            </ul>
          </li>
          <li>
            <digi-navigation-vertical-menu-item af-text="Menu item">
              <digi-icon af-name="paperclip" slot="icon"></digi-icon>
            </digi-navigation-vertical-menu-item>
          </li>
        </ul>
      <digi-navigation-vertical-menu>
    `}
	</Story>
</Canvas>

## Combined menu item

This is a menu item with a link and that has a toggle button next to it.

<Canvas>
	<Story name="Combined">
		/* html */
		{`
      <script>
        function setActiveMenuItem(target=null) {
          const menuItems = document.querySelectorAll('digi-navigation-vertical-menu-item[af-active="true"]');
          if(menuItems) {
            menuItems.forEach((el) => el.setAttribute('af-active', 'false'));
          }
          if(target) {
            target.setAttribute('af-active', 'true');
          }
        }
        document.addEventListener('afOnClick', (e) => {
          e.detail.preventDefault();
          if(e.target.matches('digi-navigation-vertical-menu-item:not([af-active-subnav])')) {
            setActiveMenuItem(e.target);
          }
        });
      </script>
      <digi-navigation-vertical-menu af-variation="secondary">
        <ul>
          <li>
            <digi-navigation-vertical-menu-item af-text="Menu item" af-active-subnav="true" af-href="#">
            </digi-navigation-vertical-menu-item>
            <ul>
              <li><digi-navigation-vertical-menu-item af-text="Menu item" af-href="#"></digi-navigation-vertical-menu-item></li>
              <li>
                <digi-navigation-vertical-menu-item af-text="Menu item 2" af-href="#" af-active="true" af-active-subnav="false"></digi-navigation-vertical-menu-item>
                <ul>
                  <li><digi-navigation-vertical-menu-item af-text="Menu item 2.1" af-href="#"></digi-navigation-vertical-menu-item></li>
                  <li><digi-navigation-vertical-menu-item af-text="Menu item 2.2" af-href="#"></digi-navigation-vertical-menu-item></li>
                  <li><digi-navigation-vertical-menu-item af-text="Menu item 2.3" af-href="#"></digi-navigation-vertical-menu-item></li>
                </ul>
              </li>
              <li><digi-navigation-vertical-menu-item af-text="Menu item 3" af-href="#"></digi-navigation-vertical-menu-item></li>
            </ul>
        </ul>
      <digi-navigation-vertical-menu>
    `}
	</Story>
</Canvas>
